#include "mbed.h"
#include "stepmotor.h"

#define MEM_SIZE 5000
#define MEM_TYPE uint32_t
#define MAXPOS 50       // en milimetros
#define SS_TIME 100     // en microsegundos
#define POSDRAW 0   
#define periodo 20
#define CM_EJECUTAR 0xff
#define CM_GUARDAR 0xfe
#define CM_VERTEX2D 0xfd
#define CM_DRAW 0xfc
#define CM_NODRAW 0xfb
#define CM_STOP 0xfa
#define CM_END 0xf0
#define CM_SMOTOR 0xf9
#define CM_DRAWMATRIX 0xf8


MEM_TYPE arreglo2[MEM_SIZE];
Serial BT(D1,D0);//(USBTX, USBRX); 
PwmOut motor_x(PB_4), motor_y(PB_5), motor_z(PB_3);
stepmotor smotor1(D9,D10,D11,D12);
stepmotor smotor2 (A0,A1,A2,A3);
int mem_head = 0,i=0,z=0;
int mem_tail = 0;
uint8_t full = 0;
char b,verificar=0;
uint32_t speed=600,h;
MEM_TYPE comando,px,py,condicionf;


int coord2us(float coord)
{
    if(0 <= coord <= MAXPOS)
        return int(800+coord*1500/50);// u6
    return 800;
 
}
 
void draw()
{
    z=coord2us(MAXPOS);
    motor_z.pulsewidth_us(z);
    wait(1);
}

void nodraw()
{  
    z=coord2us(POSDRAW);
    motor_z.pulsewidth_us(z);
    wait(1);
}

void vertex2d(float x, float y){
 
    int pulseX = coord2us(x);
    int pulseY = coord2us(y);
    
    motor_x.pulsewidth_us(pulseX);
    motor_y.pulsewidth_us(pulseY);
    wait_ms(SS_TIME);
    wait(1);
 
}
void intercambiar_motores (uint32_t cuad1,bool cw1)
{
    uint32_t count=0;
    smotor1.set_speed(speed);
    smotor2.set_speed(speed);
    for(count=0;count<=cuad1*4096;count++)
    {
        smotor1.matriz(cw1);
        smotor2.matriz(cw1);
        
    }
}
///////////////////////////////////////////////////////
void pause_play();
void ejecutar()
{
    BT.attach(&pause_play, Serial::RxIrq);
    MEM_TYPE bandera=0;
    if (mem_head==0) {BT.printf("no hay datos para ejecutar\r\n");}
    else
    { 
        BT.printf("se esta ejecutando el dibujo...\r\n");  
        for(i=0;i<mem_head-1;i++)
        { 
            bandera=arreglo2[i];
            switch (bandera)
            {
                case CM_DRAW: draw();break;
                case CM_NODRAW: nodraw(); break;
                default:
                    verificar = (uint8_t)(bandera>>16);
                    int x = (uint8_t)(bandera>>8);
                    int y = (uint8_t)(bandera);
                    if (verificar==CM_SMOTOR){intercambiar_motores((uint32_t)x,(bool)y);}
                    if (verificar==CM_VERTEX2D){vertex2d(x,y);}
                break;
            }
        }
        BT.printf("termino el dibujo\r\n");
    }
}
void pause_play()
{
    h=BT.getc();
    if (h == 0xf1)
    {
        while (h == 0xf1 or h!=0xf2)
        {
            h=BT.getc();
            wait_us(100);    
        }
        
    }    
}

uint32_t read_command()
{
   
    uint32_t val=0;
    uint8_t  cnt=0;
    
    char endc=BT.getc();
    
    while(endc != CM_END && cnt <4) {
    if(endc!=CM_END)   
        val=((val<<8) +endc);
     endc=BT.getc();
     cnt++;
    }   
    if(endc==CM_END)
        return val;
    return 0;   //al retornar 0 indica que  no se recibe el comando  
}
/////////////////////////////////////////////////////////////
void guardar()
{
    BT.printf("se inicia el comado de guardar..\r\n");    
    mem_head=0;
            do
            {
                BT.printf("entro while llenar\n\r");
                arreglo2[mem_head]= read_command();
                b=arreglo2[mem_head];
                BT.printf("posicion %i se lleno con %x\r\n",mem_head,arreglo2[mem_head]);
                mem_head++;  
            }
            while(b!=CM_STOP);
    
 }
 ///////////////////////////////////////////////////////
void dibujar_matriz(uint32_t col, uint32_t fil)
{
    bool cw=1;
    smotor1.set_speed(speed); 
    int count=0;
    int count2=0;
    draw();
    for (count2=0;count2<=1;count2++)
    {  
        smotor1.set_speed(speed); 
        smotor2.set_speed(speed); 
        for (count=0;count<=col*4096;count++)
        {
            smotor1.matriz(cw);
            smotor2.matriz(cw);
        }
        
        for (count=0;count<=2304;count++)
        {
            smotor1.set_speed(1200);
            smotor1.matriz(cw);
        }
        
        smotor1.set_speed(speed); 
        smotor2.set_speed(speed); 
        for (count=0;count<=fil*4096;count++)
        {
            smotor1.matriz(cw);
            smotor2.matriz(cw);
        }
        for (count=0;count<=2304;count++)
        {
            smotor1.set_speed(1200);
            smotor1.matriz(cw);
        }
    }
    nodraw();
}
void home()
{
    motor_x.pulsewidth_us(800);
    motor_y.pulsewidth_us(800);
    motor_z.pulsewidth_us(800);
}
 
int main() 
{
    // configuracion de periodo
    motor_x.period_ms(periodo);
    motor_y.period_ms(periodo);
    motor_z.period_ms(periodo);
    BT.baud(9600);
    
    home();
    uint32_t caracter;
    while(1)
    {
       
        caracter=read_command();
        //BT.putc('a');
        switch (caracter) 
        {
            case  CM_EJECUTAR: ejecutar(); break;
            case  CM_GUARDAR: guardar(); break;
            default: 
            
                uint32_t matriz=(uint8_t)(caracter>>16);
                uint32_t ncolum=(uint8_t)(caracter>>8);
                uint32_t nfilas=(uint8_t)(caracter);
                
                if(matriz==CM_DRAWMATRIX){dibujar_matriz(ncolum, nfilas);}//columnas y filas
               
                else
                //BT.putc(caracter);
                BT.printf("%x error de comando\r\n",caracter);
                
            break;      
        }
    }
}